

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>d2o.learn.nn.maskfactory &mdash; d2o Python Library 1.0 documentation</title>
  

  
  

  

  
  
    

  

  
  
    <link rel="stylesheet" href="../../../../_static/css/theme.css" type="text/css" />
  

  

  
    <link rel="top" title="d2o Python Library 1.0 documentation" href="../../../../index.html"/>
        <link rel="up" title="Module code" href="../../../index.html"/> 

  
  <script src="../../../../_static/js/modernizr.min.js"></script>

</head>

<body class="wy-body-for-nav" role="document">

  <div class="wy-grid-for-nav">

    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search">
          

          
            <a href="../../../../index.html" class="icon icon-home"> d2o Python Library
          

          
          </a>

          
            
            
              <div class="version">
                1.0
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
                <ul class="simple">
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
        <a href="../../../../index.html">d2o Python Library</a>
      </nav>


      
      <div class="wy-nav-content">
        <div class="rst-content">
          





<div role="navigation" aria-label="breadcrumbs navigation">
  <ul class="wy-breadcrumbs">
    <li><a href="../../../../index.html">Docs</a> &raquo;</li>
      
          <li><a href="../../../index.html">Module code</a> &raquo;</li>
      
    <li>d2o.learn.nn.maskfactory</li>
      <li class="wy-breadcrumbs-aside">
        
          
        
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <h1>Source code for d2o.learn.nn.maskfactory</h1><div class="highlight"><pre>
<span></span><span class="c1"># -*- encoding: utf-8 -*-</span>
<span class="c1">#</span>
<span class="c1"># Copyright (c) 2016 Chronos AS</span>
<span class="c1">#</span>
<span class="c1"># Authors: Fredrik Stormo, Stefan Remman</span>
<span class="c1"># Contact: kjetil.karlsen@chronosit.no</span>

<span class="c1"># TODO: File contains certain hardcoded features. Needs other solutions.</span>

<span class="kn">import</span> <span class="nn">pandas</span> <span class="kn">as</span> <span class="nn">pd</span>
<span class="kn">import</span> <span class="nn">numpy</span> <span class="kn">as</span> <span class="nn">np</span>
<span class="kn">from</span> <span class="nn">masks</span> <span class="kn">import</span> <span class="n">IndexMask</span>
<span class="kn">import</span> <span class="nn">d2o.analyze.correlation</span> <span class="kn">as</span> <span class="nn">correlation</span>
<span class="kn">import</span> <span class="nn">d2o.analyze.fourier</span> <span class="kn">as</span> <span class="nn">fourier</span>
<span class="kn">from</span> <span class="nn">d2o.utils.putils</span> <span class="kn">import</span> <span class="n">add_mav</span>


<div class="viewcode-block" id="MaskFactory"><a class="viewcode-back" href="../../../../d2o.learn.nn.html#d2o.learn.nn.maskfactory.MaskFactory">[docs]</a><span class="k">class</span> <span class="nc">MaskFactory</span><span class="p">:</span>
  <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">  Analyses a data frame and an output mask, then decides on a suitable</span>
<span class="sd">  input frame to use in time series predication.</span>
<span class="sd">  &quot;&quot;&quot;</span>
  <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span><span class="c1">#, df, output_mask):</span>
    <span class="c1">#Need for init?</span>
    <span class="k">pass</span>

  <span class="k">def</span> <span class="nf">_analyze</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">df</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">):</span>
    <span class="c1"># TODO: Implement function for threshold. (Significant update)</span>
    <span class="c1"># TODO: Add kwarg for what methods to use to analyze. (Fourier, aoutocorr, AIC, ALL, etc.)</span>
    <span class="c1"># Possible future feature, Full AIC of all interesting columns. (Significant update)</span>
    <span class="c1"># Normalize data before analyzing? what method of normalization?</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Uses correlation, autocorrelation and fourier transformation to</span>
<span class="sd">    determine how the data behaves, and what periodes to use when</span>
<span class="sd">    creating the input mask.</span>

<span class="sd">    Returns</span>
<span class="sd">    -------</span>
<span class="sd">    analyze_results : dict</span>
<span class="sd">      Contains the indexes found to be of interest assigned to the keys</span>
<span class="sd">      of the colum they came from.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">keys</span> <span class="o">=</span> <span class="n">kwargs</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;key&quot;</span><span class="p">,</span> <span class="s2">&quot;ALL&quot;</span><span class="p">)</span>
    <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">keys</span> <span class="o">==</span> <span class="s2">&quot;ALL&quot;</span><span class="p">:</span>
      <span class="bp">self</span><span class="o">.</span><span class="n">keys</span> <span class="o">=</span> <span class="n">df</span><span class="o">.</span><span class="n">columns</span><span class="o">.</span><span class="n">values</span><span class="o">.</span><span class="n">tolist</span><span class="p">()</span>
    <span class="k">elif</span> <span class="nb">type</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">keys</span><span class="p">)</span> <span class="o">==</span> <span class="nb">str</span><span class="p">:</span>
      <span class="bp">self</span><span class="o">.</span><span class="n">keys</span> <span class="o">=</span> <span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">keys</span><span class="p">]</span> <span class="c1">#Needs to be list for itteration purposes.</span>

    <span class="n">mav_width</span> <span class="o">=</span> <span class="n">kwargs</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;mav_width&quot;</span><span class="p">,</span> <span class="mi">20</span><span class="p">)</span> <span class="c1"># TODO: Arbitrarily set to 20. Find a more robust solution?</span>
    <span class="n">mav_df</span> <span class="o">=</span> <span class="n">add_mav</span><span class="p">(</span><span class="n">df</span><span class="p">,</span> <span class="n">mav_width</span><span class="p">)</span>

    <span class="c1">#This part needs testing. Do mav_df contain the original columns?</span>
    <span class="c1">#Remove addition in key name from add_mav(), &quot;_MAV(XX)&quot;</span>
    <span class="n">rename_dict</span> <span class="o">=</span> <span class="p">{}</span>
    <span class="n">length_of_addition</span> <span class="o">=</span> <span class="mi">6</span> <span class="o">+</span> <span class="nb">len</span><span class="p">(</span><span class="nb">str</span><span class="p">(</span><span class="n">mav_width</span><span class="p">))</span>
    <span class="k">for</span> <span class="n">key</span> <span class="ow">in</span> <span class="n">mav_df</span><span class="p">:</span>
      <span class="n">rename_dict</span><span class="p">[</span><span class="n">key</span><span class="p">]</span> <span class="o">=</span> <span class="n">key</span><span class="p">[</span><span class="mi">0</span><span class="p">:</span><span class="o">-</span><span class="n">length_of_addition</span><span class="p">]</span>
    <span class="n">mav_df</span><span class="o">.</span><span class="n">rename</span><span class="p">(</span><span class="n">index</span><span class="o">=</span><span class="nb">str</span><span class="p">,</span> <span class="n">columns</span><span class="o">=</span><span class="n">rename_dict</span><span class="p">,</span> <span class="n">inplace</span><span class="o">=</span><span class="bp">True</span><span class="p">)</span>

    <span class="n">threshold</span> <span class="o">=</span> <span class="n">kwargs</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;threshold&quot;</span><span class="p">,</span> <span class="mf">0.1</span><span class="p">)</span> <span class="c1"># TODO: find robust solution for threshold.</span>

    <span class="n">results_fft</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">_get_fourier_frequencies</span><span class="p">(</span><span class="n">mav_df</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">keys</span><span class="p">,</span> <span class="n">threshold</span><span class="p">)</span>
    <span class="n">results_pac</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">_get_partial_autocorr_lags</span><span class="p">(</span><span class="n">mav_df</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">keys</span><span class="p">,</span> <span class="n">threshold</span><span class="p">)</span>

    <span class="c1">#Join lists</span>
    <span class="n">analyze_results</span> <span class="o">=</span> <span class="p">{}</span>
    <span class="k">for</span> <span class="n">key</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">keys</span><span class="p">:</span>
<span class="c1">#      print &quot;FFT:&quot;, results_fft[key], &quot;PAC:&quot;, results_pac[key]</span>
      <span class="n">analyze_results</span><span class="p">[</span><span class="n">key</span><span class="p">]</span> <span class="o">=</span> <span class="n">results_pac</span><span class="p">[</span><span class="n">key</span><span class="p">]</span> <span class="c1">#+ results_fft[key]</span>
<span class="c1">#      print &quot;Joined:&quot;, analyze_results[key]</span>

<span class="c1">#    print &quot;analyze_results:&quot;</span>
<span class="c1">#    print analyze_results</span>
    <span class="k">return</span> <span class="n">analyze_results</span>

  <span class="k">def</span> <span class="nf">_create_mask</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">df</span><span class="p">,</span> <span class="n">output_mask</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">):</span>
    <span class="c1"># TODO: Optional to invert indexes?</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Uses the output_mask and analyzes df to produce an input mask.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">indexes_dict</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">_analyze</span><span class="p">(</span><span class="n">df</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">)</span>

    <span class="n">padding</span> <span class="o">=</span> <span class="n">kwargs</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;padding&quot;</span><span class="p">,</span> <span class="mi">5</span><span class="p">)</span> <span class="c1">#Arbitrary default padding.</span>
    <span class="n">indexes_dict</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">_add_padding</span><span class="p">(</span><span class="n">indexes_dict</span><span class="p">,</span> <span class="n">padding</span><span class="p">)</span>

    <span class="n">max_gap</span> <span class="o">=</span> <span class="n">kwargs</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;max_gap&quot;</span><span class="p">,</span> <span class="mi">3</span><span class="p">)</span> <span class="c1">#Arbitrary default gap.</span>
    <span class="n">indexes_dict</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">_splitt_list</span><span class="p">(</span><span class="n">indexes_dict</span><span class="p">,</span> <span class="n">max_gap</span><span class="p">)</span>

    <span class="n">indexes_dict</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">_invert_indexes</span><span class="p">(</span><span class="n">indexes_dict</span><span class="p">)</span>

    <span class="n">input_mask</span> <span class="o">=</span> <span class="n">IndexMask</span><span class="p">(</span><span class="n">indexes_dict</span><span class="p">)</span>
    <span class="k">return</span> <span class="n">input_mask</span>

  <span class="k">def</span> <span class="nf">_add_padding</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">indexes_dict</span><span class="p">,</span> <span class="n">padding</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Adds padding on each index in list supplied. Does not add negative</span>
<span class="sd">    values.</span>

<span class="sd">    Returns</span>
<span class="sd">    -------</span>
<span class="sd">    unique_indexes_dict : dict</span>
<span class="sd">      Dict with sorted lists with unique elements.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">unique_indexes_dict</span> <span class="o">=</span> <span class="p">{}</span>
    <span class="k">for</span> <span class="n">key</span> <span class="ow">in</span> <span class="n">indexes_dict</span><span class="p">:</span>
      <span class="n">indexes</span> <span class="o">=</span> <span class="n">indexes_dict</span><span class="p">[</span><span class="n">key</span><span class="p">]</span>
      <span class="n">unique_indexes</span> <span class="o">=</span> <span class="p">[]</span>
      <span class="k">for</span> <span class="n">element</span> <span class="ow">in</span> <span class="n">indexes</span><span class="p">:</span>
        <span class="k">if</span> <span class="n">padding</span> <span class="o">&gt;=</span> <span class="n">element</span><span class="p">:</span>
          <span class="k">for</span> <span class="n">new_element</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span> <span class="n">element</span><span class="o">+</span><span class="n">padding</span><span class="o">+</span><span class="mi">1</span><span class="p">):</span>
            <span class="n">unique_indexes</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">new_element</span><span class="p">)</span>
        <span class="k">else</span><span class="p">:</span>
          <span class="k">for</span> <span class="n">new_element</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">element</span><span class="o">-</span><span class="n">padding</span><span class="p">,</span> <span class="n">element</span><span class="o">+</span><span class="n">padding</span><span class="o">+</span><span class="mi">1</span><span class="p">):</span>
            <span class="n">unique_indexes</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">new_element</span><span class="p">)</span>
      <span class="n">unique_indexes</span> <span class="o">=</span> <span class="nb">sorted</span><span class="p">(</span><span class="nb">set</span><span class="p">(</span><span class="n">unique_indexes</span><span class="p">))</span>
      <span class="n">unique_indexes_dict</span><span class="p">[</span><span class="n">key</span><span class="p">]</span> <span class="o">=</span> <span class="n">unique_indexes</span>
    <span class="k">return</span> <span class="n">unique_indexes_dict</span>

  <span class="k">def</span> <span class="nf">_splitt_list</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">padded_dict</span><span class="p">,</span> <span class="n">max_gap</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Splits the list in to a list of sublist based on the numbers in that</span>
<span class="sd">    list, and the gap allowed between numbers.</span>

<span class="sd">    Returns</span>
<span class="sd">    -------</span>
<span class="sd">    splitted_list_dict : dict of lists of np.arrays</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">splitt_list_dict</span> <span class="o">=</span> <span class="p">{}</span>
    <span class="k">for</span> <span class="n">key</span> <span class="ow">in</span> <span class="n">padded_dict</span><span class="p">:</span>
      <span class="n">padded_list</span> <span class="o">=</span> <span class="n">padded_dict</span><span class="p">[</span><span class="n">key</span><span class="p">]</span>
      <span class="n">splitted_list</span> <span class="o">=</span> <span class="p">[]</span>
      <span class="n">sub_list</span> <span class="o">=</span> <span class="p">[</span><span class="n">padded_list</span><span class="p">[</span><span class="mi">0</span><span class="p">]]</span>

      <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">xrange</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">padded_list</span><span class="p">)</span><span class="o">-</span><span class="mi">1</span><span class="p">):</span>
        <span class="k">if</span> <span class="n">padded_list</span><span class="p">[</span><span class="n">i</span><span class="o">+</span><span class="mi">1</span><span class="p">]</span> <span class="o">-</span> <span class="n">padded_list</span><span class="p">[</span><span class="n">i</span><span class="p">]</span> <span class="o">&lt;=</span> <span class="n">max_gap</span><span class="p">:</span>
          <span class="n">sub_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">padded_list</span><span class="p">[</span><span class="n">i</span><span class="o">+</span><span class="mi">1</span><span class="p">])</span>
        <span class="k">else</span><span class="p">:</span>
          <span class="n">splitted_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="n">sub_list</span><span class="p">))</span>
          <span class="n">sub_list</span> <span class="o">=</span> <span class="p">[</span><span class="n">padded_list</span><span class="p">[</span><span class="n">i</span><span class="o">+</span><span class="mi">1</span><span class="p">]]</span>

      <span class="n">splitted_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="n">sub_list</span><span class="p">))</span>
      <span class="n">splitt_list_dict</span><span class="p">[</span><span class="n">key</span><span class="p">]</span> <span class="o">=</span> <span class="n">splitted_list</span>
    <span class="k">return</span> <span class="n">splitt_list_dict</span>

<div class="viewcode-block" id="MaskFactory.get_mask"><a class="viewcode-back" href="../../../../d2o.learn.nn.html#d2o.learn.nn.maskfactory.MaskFactory.get_mask">[docs]</a>  <span class="k">def</span> <span class="nf">get_mask</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">df</span><span class="p">,</span> <span class="n">output_mask</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Analyzes data frame and output_mask, and returns an input mask</span>

<span class="sd">    Parameters</span>
<span class="sd">    ----------</span>
<span class="sd">    df : pd.DataFrame</span>

<span class="sd">    outputMask : IndexMask</span>
<span class="sd">      Type is from clib/learn/nn/masks.py</span>

<span class="sd">    kwargs</span>
<span class="sd">    ------</span>
<span class="sd">    keys : str, list of strings, defaults &quot;ALL&quot;.</span>
<span class="sd">      What columns in df to analyze and return mask for.</span>

<span class="sd">    threshold : float, default .2</span>
<span class="sd">      Number between 0 and 1.</span>

<span class="sd">    padding : int</span>
<span class="sd">      How much padding to add on either side of the indexes found in analyze.</span>

<span class="sd">    max_gap : int</span>
<span class="sd">      The largest gap allowed in a sub list in the returned mask.</span>

<span class="sd">    Returns</span>
<span class="sd">    -------</span>
<span class="sd">    input_mask : IndexMask</span>
<span class="sd">      From clib/learn/nn/masks.py</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">input_mask</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">_create_mask</span><span class="p">(</span><span class="n">df</span><span class="p">,</span> <span class="n">output_mask</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">)</span>

    <span class="k">return</span> <span class="n">input_mask</span></div>

  <span class="k">def</span> <span class="nf">_get_fourier_frequencies</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">df</span><span class="p">,</span> <span class="n">keys</span><span class="p">,</span> <span class="n">threshold</span><span class="o">=.</span><span class="mi">2</span><span class="p">):</span>
    <span class="c1"># TODO: Most of this function is repeated in _get_partial_autocorr_lags(), seperate in to own function?</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Analyzes the dataframe and returns the interesting frequencies for</span>
<span class="sd">    use in making the mask this class produces.</span>

<span class="sd">    Parameters</span>
<span class="sd">    ----------</span>
<span class="sd">    df : pd.DataFrame</span>

<span class="sd">    Returns</span>
<span class="sd">    -------</span>
<span class="sd">    fourier_dict : dict</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">fourier_df</span> <span class="o">=</span> <span class="n">fourier</span><span class="o">.</span><span class="n">fftdf</span><span class="p">(</span><span class="n">df</span><span class="p">,</span> <span class="n">keys</span><span class="p">)</span>

    <span class="n">fourier_dict</span> <span class="o">=</span> <span class="p">{}</span>
    <span class="k">for</span> <span class="n">key</span> <span class="ow">in</span> <span class="n">keys</span><span class="p">:</span>
      <span class="n">indexes</span> <span class="o">=</span> <span class="p">[]</span>
      <span class="n">index</span> <span class="o">=</span> <span class="mi">1</span>

      <span class="n">fourier_max</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">max</span><span class="p">(</span><span class="n">fourier_df</span><span class="p">[</span><span class="n">key</span><span class="p">]</span><span class="o">.</span><span class="n">values</span><span class="p">[</span><span class="mi">1</span><span class="p">:</span><span class="o">-</span><span class="mi">1</span><span class="p">])</span>
      <span class="k">for</span> <span class="n">element</span> <span class="ow">in</span> <span class="n">fourier_df</span><span class="p">[</span><span class="n">key</span><span class="p">]</span><span class="o">.</span><span class="n">values</span><span class="p">:</span>
        <span class="k">if</span> <span class="n">element</span> <span class="o">&gt;</span> <span class="n">fourier_max</span><span class="o">*</span><span class="n">threshold</span><span class="p">:</span> <span class="c1"># TODO: Move multiplication outside loop.</span>
          <span class="n">indexes</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">index</span><span class="p">)</span>
        <span class="n">index</span> <span class="o">+=</span> <span class="mi">1</span>

      <span class="n">fourier_dict</span><span class="p">[</span><span class="n">key</span><span class="p">]</span> <span class="o">=</span> <span class="n">indexes</span>
    <span class="k">return</span> <span class="n">fourier_dict</span>

  <span class="k">def</span> <span class="nf">_get_partial_autocorr_lags</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">df</span><span class="p">,</span> <span class="n">keys</span><span class="p">,</span> <span class="n">threshold</span><span class="o">=.</span><span class="mi">2</span><span class="p">,</span> <span class="n">nlags</span><span class="o">=</span><span class="mi">370</span><span class="p">):</span>
    <span class="c1"># TODO: Include indexes with significant negative corelation?</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Does a partial autocorrelation and returns the index lags that show greatest correlation.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">pac_df</span> <span class="o">=</span> <span class="n">correlation</span><span class="o">.</span><span class="n">partial_autocorr</span><span class="p">(</span><span class="n">df</span><span class="p">,</span> <span class="n">nlags</span><span class="o">=</span><span class="n">nlags</span><span class="p">,</span> <span class="n">keys</span><span class="o">=</span><span class="n">keys</span><span class="p">)</span>

    <span class="n">pac_dict</span> <span class="o">=</span> <span class="p">{}</span>
    <span class="k">for</span> <span class="n">key</span> <span class="ow">in</span> <span class="n">keys</span><span class="p">:</span>
      <span class="n">indexes</span> <span class="o">=</span> <span class="p">[]</span>
      <span class="n">index</span> <span class="o">=</span> <span class="mi">1</span>

      <span class="n">pac_max</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">max</span><span class="p">(</span><span class="n">pac_df</span><span class="p">[</span><span class="n">key</span><span class="o">+</span><span class="s2">&quot;_PACF&quot;</span><span class="p">]</span><span class="o">.</span><span class="n">values</span><span class="p">[</span><span class="mi">1</span><span class="p">:</span><span class="o">-</span><span class="mi">1</span><span class="p">])</span>
      <span class="k">for</span> <span class="n">element</span> <span class="ow">in</span> <span class="n">pac_df</span><span class="p">[</span><span class="n">key</span><span class="o">+</span><span class="s2">&quot;_PACF&quot;</span><span class="p">]</span><span class="o">.</span><span class="n">values</span><span class="p">:</span>
        <span class="k">if</span> <span class="n">element</span> <span class="o">&gt;</span> <span class="n">pac_max</span><span class="o">*</span><span class="n">threshold</span><span class="p">:</span>
          <span class="n">indexes</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">index</span><span class="p">)</span>
        <span class="n">index</span> <span class="o">+=</span> <span class="mi">1</span>

      <span class="n">pac_dict</span><span class="p">[</span><span class="n">key</span><span class="p">]</span> <span class="o">=</span> <span class="n">indexes</span>
    <span class="k">return</span> <span class="n">pac_dict</span>

  <span class="k">def</span> <span class="nf">_invert_indexes</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">a_dict</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Inverts the elements in a_dict.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">for</span> <span class="n">key</span> <span class="ow">in</span> <span class="n">a_dict</span><span class="p">:</span>
      <span class="k">for</span> <span class="n">a_list</span> <span class="ow">in</span> <span class="n">a_dict</span><span class="p">[</span><span class="n">key</span><span class="p">]:</span>
        <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">xrange</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">a_list</span><span class="p">)):</span>
          <span class="n">a_list</span><span class="p">[</span><span class="n">i</span><span class="p">]</span> <span class="o">=</span> <span class="o">-</span><span class="n">a_list</span><span class="p">[</span><span class="n">i</span><span class="p">]</span>
    <span class="k">return</span> <span class="n">a_dict</span></div>

<span class="k">if</span> <span class="n">__name__</span> <span class="o">==</span> <span class="s2">&quot;__main__&quot;</span><span class="p">:</span>
  <span class="k">print</span> <span class="s2">&quot;a test block&quot;</span>


</pre></div>

           </div>
          </div>
          <footer>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2016, Chronos AS.

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/snide/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  

    <script type="text/javascript">
        var DOCUMENTATION_OPTIONS = {
            URL_ROOT:'../../../../',
            VERSION:'1.0',
            COLLAPSE_INDEX:false,
            FILE_SUFFIX:'.html',
            HAS_SOURCE:  true
        };
    </script>
      <script type="text/javascript" src="../../../../_static/jquery.js"></script>
      <script type="text/javascript" src="../../../../_static/underscore.js"></script>
      <script type="text/javascript" src="../../../../_static/doctools.js"></script>
      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>

  

  
  
    <script type="text/javascript" src="../../../../_static/js/theme.js"></script>
  

  
  
  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.StickyNav.enable();
      });
  </script>
   

</body>
</html>